(import simple-sequences)

(import (chicken condition) simple-tests)

(define-checks
  (seq-db verbose? lst '(0 1 2 3) pls '(0 1 2 . 3) vec #(0 1 2 3) str "0123")
  (sequence-db '())
  (vector length list-ref list-tail list)
  (sequence-db #())
  (vector vector-length vector-ref subvector vector)
  (sequence-db "")
  (vector string-length string-ref substring string)
  (seq-length '())
  0
  (seq-length #())
  0
  (seq-length "")
  0
  (seq-length '(1 . 2))
  1
  (seq-length 1)
  0
  (seq-ref '(0 1 2 3) 1)
  1
  (seq-ref #(0 1 2 3) 1)
  1
  (seq-ref "0123" 1)
  #\1
  (seq-ref '(0 1 2 . 3) 1)
  1
  (seq-tail '(0 1 2 3 4) 1)
  '(1 2 3 4)
  (seq-tail #(0 1 2 3 4) 1)
  #(1 2 3 4)
  (seq-tail "01234" 1)
  "1234"
  (seq-tail '(0 1 2 3 . 4) 1)
  '(1 2 3 . 4)
  (seq-tail '(0 1 2 3 . 4) 4)
  4
  (seq-tail 1 0)
  1
  (sequence? 1)
  #f
  (length (sequence-db))
  5
  (list-ref
    (sequence-db
      number?
      (lambda (x) 0)
      (lambda (x i) (error))
      (lambda (x i) x)
      (lambda (x) x))
    4)
  number?
  (car (sequence-db
         integer?
         (lambda (x) 0)
         (lambda (x i) (error))
         (lambda (x i) x)
         (lambda (x) x)
         list?))
  integer?
  (length (sequence-db))
  5
  (condition-case (seq-ref 1 0) ((exn) "out of range"))
  "out of range"
  (seq-tail 1 0)
  1
  (condition-case (seq-tail 1 1) ((exn) "out of range"))
  "out of range")

(define-checks
  (flat verbose? lst '(0 1 2 3) pls '(0 1 2 . 3) vec #(0 1 2 3) str "0123")
  (sequence->list '(0 1 2 . 3))
  '(0 1 2)
  (seq-maker str)
  string
  (subseq str 1)
  "123"
  (subseq str 1 3)
  "12"
  (subseq pls 1 3)
  '(1 2 . 3)
  (seq-nil str)
  ""
  (seq-nil pls)
  3
  (seq-pseudo? pls)
  #t
  (seq-pseudo? lst)
  #f
  (seq-reverse "abc")
  "cba"
  (seq-reverse '(1 2 3 . 0))
  '(3 2 1 . 0)
  (receive (odd even) (seq-filter odd? vec) (list odd even))
  '(#(1 3) #(0 2))
  (receive (odd even) (seq-filter odd? pls) (list odd even))
  '((1 . 3) (0 2 . 3))
  (seq-memp odd? vec)
  #(1 2 3)
  (seq-memp odd? pls)
  '(1 2 . 3)
  (seq-memp (lambda (s) (char=? s #\2)) str)
  "23"
  (seq-append #(1 2 3) #(10 20 30))
  #(1 2 3 10 20 30)
  (seq-append '(1 2 3 . 0) '(10 20 30 . 0))
  '(1 2 3 10 20 30 . 0)
  (seq-append "a" "b" "c" "d" "e")
  "abcde"
  (seq-map add1 #(0 1 2))
  #(1 2 3)
  (seq-map add1 '(0 1 2 . 0))
  '(1 2 3 . 0)
  (seq-map + #(1 2 3) #(10 20 30 40))
  #(11 22 33)
  (seq-map + '(1 2 . 0) '(10 20 . 0))
  '(11 22 . 0)
  (condition-case
    (seq-map + '(1 2 . 3) '(10 20 . 30))
    ((exn) "different nils"))
  "different nils")

(define-checks
  (nested verbose?)
  (seq-ref* '(1 #(2 3)) '(1 0))
  2
  (seq-ref* '(0 #(1 "23")) '(1 1 1))
  #\3
  (seq-ref* '(0 #(1 "23")) '(1 0))
  1
  (seq-ref* '(0 #(1 "23")) '(1 1))
  "23"
  (seq-flat? #(1 2 3))
  #t
  (seq-flat? '(1 #(2 3)))
  #f
  (seq-length* '((2 (3 #(4) 5) 1) 0))
  6
  (seq-length* '(1 #(2 "3")))
  3
  (seq-length* '(((((0))))))
  1
  (seq-map* add1 '(((2) 1) 0))
  '(((3) 2) 1)
  (seq-map* add1 '(0 #(1 2)))
  '(1 #(2 3))
  (seq-map* add1 '(0 (1 2 . 3)))
  '(1 (2 3 . 3))
  (seq-map* add1 '(0 (1 (2 . 3))))
  '(1 (2 (3 . 3)))
  (seq-map* add1 '(0 (1 (2 . 3) . 0)))
  '(1 (2 (3 . 3) . 0)))

(check-all SIMPLE-SEQUENCES
  (seq-db)
  (flat)
  (nested)
  )
